"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class ServerManager {
    constructor() {
        this.servers = new Map();
    }
    start(routeDefinitions) {
        return __awaiter(this, void 0, void 0, function* () {
            Array.from(this.servers.values()).reduce((current, server) => __awaiter(this, void 0, void 0, function* () {
                current.then(() => __awaiter(this, void 0, void 0, function* () {
                    yield server.start(routeDefinitions);
                }));
            }), Promise.resolve(null));
        });
    }
    stop() {
        return __awaiter(this, void 0, void 0, function* () {
            const promises = [];
            Array.from(this.servers.values()).forEach((server) => promises.push(server.stopEngine()));
            yield Promise.all(promises);
        });
    }
}
ServerManager.ns = 'server';
exports.ServerManager = ServerManager;

//# sourceMappingURL=server-manager.js.map
